;===================================================================
;                   MAIN.ASM
;       sets BL =1, AX = 555H
;       calls Reseed
; Calls Rand 100 times w/ lower=0 upper = 9999
; Prints values 10 numbers/line and 6 ch/number and right justify
; Counts low values (0-4999) and high values (5000-9999)
; Counts evens and odds
; Sets BL=0
; Calls Reseed
; Calls Rand 100 times w/ lower=0 upper = 9999
; Prints values 10 numbers/line and 6 ch/number and right justify
; Counts low values (0-4999) and high values (5000-9999)
; Counts evens and odds
; Prints statistics (#/200)
;
;===================================================================

;        EXTERN  GETDEC:FAR
;        EXTERN  NEWLINE:FAR
;        EXTERN  PutDec:FAR
;        EXTERN  PUTSTRNG:FAR
        EXTERN  NRANDOM:FAR
        EXTERN  RESEED:FAR

;===================================================================

        .MODEL  LARGE      ;,BASIC
        .STACK  512        ;256

;===================================================================

; D A T A   S E G M E N T   D E F I N I T I O N

        .DATA

UPPER      DW      9999
LOWER      DW      0

HIGHCOUNT  DW 0
LOWCOUNT   DW 0
EVENCOUNT  DW 0
ODDCOUNT   DW 0
HIGHHEADER DB 'High numbers: ',24h
LOWHEADER  DB ' Low numbers: ',24h
ODDHEADER  DB ' Odd numbers: ',24h
EVENHEADER DB 'Even numbers: ',24h

;===================================================================

; C O D E   S E G M E N T   D E F I N I T I O N

        .CODE
        ASSUME  DS:DGROUP

;-------------------------------------------------------------------

MAIN    PROC

        MOV     AX,DGROUP           ;SET DS-REGISTER TO POINT TO
        MOV     DS,AX               ;DATA SEGMENT

        MOV     BL,1                ;if bl=1, we get 5555h for a seed
        CALL    RESEED
        MOV     CX,100              ;   LOOP_COUNT = 100

NUM_LOOP:
        PUSH    CX                  ;      PUSH LOOP_COUNT
        MOV     AX,UPPER            ;PUSH UPPER
        PUSH    AX
        MOV     AX,LOWER            ;PUSH LOWER
        PUSH    AX             
        CALL    NRANDOM

        call    U2Dec

        CMP     AX,5000
        JAE     HIGH_SEQUENCE       ;a count below 5000 gets counted as both high and low ?

        INC     LOWCOUNT
        JMP SHORT HILO_COUNTED

HIGH_SEQUENCE:
        INC     HIGHCOUNT

HILO_COUNTED:
        shr     ax,1
        jc      ODDS

        INC     EVENCOUNT
        jmp short EVENODD_COUNTED

ODDS:
        INC     ODDCOUNT

EVENODD_COUNTED:
        POP     CX                  ;      POP LOOP_COUNT
        LOOP    NUM_LOOP            ;      DECREMENT LOOP_COUNT
                                    ;   UNTIL LOOP_COUNT = 0

;        MOV     BL,0
;        CALL    RESEED

;        LEA     DI,HIGHHEADER       ;could be MOV DI,OFFSET HIGHHEADER
;        MOV     CX,18               ;i count 14, but ok - i would try to use MOV CX,SIZEOF HIGHHEADER
;        CALL    PUTSTRNG
;        CALL    NEWLINE

        mov     dx,offset HIGHHEADER
        mov     ah,9
        int     21h
        mov     ax,HIGHCOUNT
        call    U2Dec

        mov     dx,offset LOWHEADER
        mov     ah,9
        int     21h
        mov     ax,LOWCOUNT
        call    U2Dec

        mov     dx,offset ODDHEADER
        mov     ah,9
        int     21h
        mov     ax,ODDCOUNT
        call    U2Dec

        mov     dx,offset EVENHEADER
        mov     ah,9
        int     21h
        mov     ax,EVENCOUNT
        call    U2Dec

;terminate

        MOV     AX,4C00H
        INT     21H

MAIN    ENDP

;-------------------------------------------------------------------

U2Dec   PROC

;display unsigned word from AX in decimal
;the number is terminated with a carriage return/line feed
;all registers are preserved, including flags

        pushf
        push    ax
        push    bx
        push    cx
        push    dx
        push    si
        push    di
        push    bp
        mov     bx,240Ah             ;line feed and terminator
        push    bx
        mov     bx,0D00h             ;carriage return
        push    bx
        mov     bp,sp
        sub     sp,4
        mov     bx,10

U2Dec0: xor     dx,dx
        div     bx
        or      dl,30h
        mov     [bp],dl
        dec     bp
        or      ax,ax
        jnz     U2Dec0

        inc     bp
        mov     dx,bp
        mov     ah,9
        push    ds
        push    ss
        pop     ds
        int     21h
        pop     ds

        add     sp,8
        pop     bp
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        popf
        ret

U2Dec   ENDP

;-------------------------------------------------------------------

        END     MAIN

